-- myDebug v1.3 --


--------------------------------------------------------------------------------------------------
-- Global variables
--------------------------------------------------------------------------------------------------

BINDING_HEADER_MYDEBUG = "myDebug";
myDebugScripts = {};


--------------------------------------------------------------------------------------------------
-- Local variables
--------------------------------------------------------------------------------------------------

local MYDEBUG_NAME = "myDebug";
local MYDEBUG_VERSION = "1.3-mikk-20060702";
local MYDEBUG_AUTHOR = "Scheid";
local MYDEBUG_EMAIL = "scheid@free.fr";
local MYDEBUG_WEBSITE = "http://scheid.free.fr";
-- BEGIN Mikk 2006-05-07
local MYDEBUG_MAXTREEDEPTH = 20;
-- END
local myDebugVariableTree = {};


--------------------------------------------------------------------------------------------------
-- Popup Dialogs
--------------------------------------------------------------------------------------------------

StaticPopupDialogs["MYDEBUG_VARIABLE_INSERT_FORCE"] = {
	text = TEXT(MYDEBUG_VARIABLE_INSERT_FORCE),
	button1 = TEXT(YES),
	button2 = TEXT(NO),
	OnAccept = function(parameters)
		myDebugVariableFrame_EditVariable(parameters.parentIndex, {});
		myDebugVariableFrame_Refresh();
		myDebugVariableFrame_InsertVariable(parameters.parentIndex, parameters.variableName, parameters.value);
	end,
	timeout = 0,
	whileDead = 1,
	showAlert = 1
};
StaticPopupDialogs["MYDEBUG_VARIABLE_INSERT_NAME"] = {
	text = TEXT(MYDEBUG_VARIABLE_INSERT_NAME),
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 100,
	OnAccept = function(parameters)
		myDebugVariableFrame_InsertVariable(parameters.parentIndex, getglobal(this:GetParent():GetName().."EditBox"):GetText(), parameters.value);
	end,
	OnShow = function()
		this:SetPoint("TOP", "UIParent", "TOP", 0, -128);
		getglobal(this:GetName().."EditBox"):SetFocus();
	end,
	OnHide = function()
		getglobal(this:GetName().."EditBox"):SetText("");
	end,
	EditBoxOnEnterPressed = function(parameters)
		StaticPopup_OnClick(getglobal(this:GetParent():GetName()), 1);
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide();
	end,
	timeout = 0,
	whileDead = 1
};
StaticPopupDialogs["MYDEBUG_VARIABLE_INSERT_VALUE"] = {
	text = TEXT(MYDEBUG_VARIABLE_INSERT_VALUE),
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 100,
	OnAccept = function(parameters)
		myDebugVariableFrame_InsertVariable(parameters.parentIndex, parameters.variableName, getglobal(this:GetParent():GetName().."EditBox"):GetText());
	end,
	OnShow = function()
		this:SetPoint("TOP", "UIParent", "TOP", 0, -128);
		getglobal(this:GetName().."EditBox"):SetFocus();
	end,
	OnHide = function()
		getglobal(this:GetName().."EditBox"):SetText("");
	end,
	EditBoxOnEnterPressed = function(parameters)
		StaticPopup_OnClick(getglobal(this:GetParent():GetName()), 1);
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide();
	end,
	timeout = 0,
	whileDead = 1
};
StaticPopupDialogs["MYDEBUG_VARIABLE_EDIT"] = {
	text = TEXT(MYDEBUG_VARIABLE_EDIT),
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 100,
	OnAccept = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox");
		myDebugVariableFrame_EditVariable(myDebugVariableTree.selectedIndex, editBox:GetText());
		myDebugVariableFrame_Refresh();
	end,
	OnShow = function()
		getglobal(this:GetName().."EditBox"):SetFocus();
	end,
	OnHide = function()
		getglobal(this:GetName().."EditBox"):SetText("");
	end,
	EditBoxOnEnterPressed = function()
		StaticPopup_OnClick(getglobal(this:GetParent():GetName()), 1);
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide();
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1
};
StaticPopupDialogs["MYDEBUG_VARIABLE_DELETE"] = {
	text = TEXT(MYDEBUG_VARIABLE_DELETE),
	button1 = TEXT(YES),
	button2 = TEXT(NO),
	OnAccept = function()
		myDebugVariableFrame_EditVariable(myDebugVariableTree.selectedIndex, nil);
		myDebugVariableFrame_Refresh();
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	showAlert = 1
};
StaticPopupDialogs["MYDEBUG_SCRIPTS_CLEAR"] = {
	text = TEXT(MYDEBUG_SCRIPTS_CLEAR),
	button1 = TEXT(MYDEBUG_SCRIPTS_CURRENT),
	button2 = TEXT(MYDEBUG_SCRIPTS_ALL),
	OnAccept = function()
		myDebugScriptsFrame_Clear(myDebugScripts.currentScript);
	end,
	OnCancel = function()
		myDebugScriptsFrame_Clear();
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
};


--------------------------------------------------------------------------------------------------
-- Event functions
--------------------------------------------------------------------------------------------------

-- OnLoad event
function myDebugFrame_OnLoad()

	-- Register the events that need to be watched
	this:RegisterEvent("ADDON_LOADED");
	
	-- Register the frame in the UIPanelWindows table
	UIPanelWindows[this:GetName()] = {area = "doublewide", pushable = 0};
	
	-- Set the number of tabs for the frame
	PanelTemplates_SetNumTabs(this, 2);

end

-- OnEvent event
function myDebugFrame_OnEvent()

	-- Check the current event
	if (event == "ADDON_LOADED" and arg1 == MYDEBUG_NAME) then
		-- Initialize the addon
		myDebugFrame_Initialize();
		
-- BEGIN Mikk 2006-05-07
		SLASH_MYDEBUG1 = "/mydebug";
		SLASH_MYDEBUG2 = "/myd";
		SlashCmdList["MYDEBUG"] = function(msg)
			myDebugFrame_SlashCommand(msg);
		end
-- END Mikk 2006-05-07

	end

end

-- BEGIN Mikk 2006-05-07
-- Slash Command
function myDebugFrame_SlashCommand(msg)
	local a1,a2,a3,a4,a5;
	_,_,a1 = string.find(msg, "^exec +(%d+) *$");
	if(tonumber(a1)) then
		myDebugScriptsFrame_Execute(tonumber(a1));
		return;
	end

	_,_,a1 = string.find(msg, "^edit +(%d+) *$");
	if(tonumber(a1)) then
		if(not myDebugFrame:IsVisible()) then
			ShowUIPanel(myDebugFrame);
		end
		myDebugFrameTab_OnClick(2);
		myDebugScriptsFrame_Goto(tonumber(a1));
		return;
	end

	_,_,a1 = string.find(msg, "^show +([%a_][%a%d_]*) *$");
	if(a1) then
		if(not myDebugFrame:IsVisible()) then
			ShowUIPanel(myDebugFrame);
		end
		myDebugFrameTab_OnClick(1);
		myDebugVariableFrameEditBox:SetText(a1);
		myDebugVariableFrame_Refresh();
		return;
	end

	DEFAULT_CHAT_FRAME:AddMessage(MYDEBUG_SLASHCMD_HELP);

end
-- END Mikk 2006-05-07



-- OnShow event
function myDebugFrame_OnShow()

	-- Play the opening sound
	PlaySound("igCharacterInfoOpen");

end

-- OnHide event
function myDebugFrame_OnHide()

	-- Play the closing sound
	PlaySound("igCharacterInfoClose");

end

-- Tab OnClick event
function myDebugFrameTab_OnClick(tab)

	-- Get the clicked tab
	if (not tab) then
		tab = this:GetID();
	end
	
	-- Set the selected tab
	PanelTemplates_SetTab(myDebugFrame, tab);
	
	-- Check which tab was clicked
	if (tab == 1) then
		-- Variable tab clicked
		myDebugScriptsFrame:Hide();
		myDebugFrameBottomLeft:SetTexture("Interface\\FriendsFrame\\WhoFrame-BotLeft");
		myDebugFrameBottomCenterLeft:SetTexture("Interface\\FriendsFrame\\WhoFrame-BotLeft");
		myDebugFrameBottomCenterRight:SetTexture("Interface\\FriendsFrame\\WhoFrame-BotLeft");
		myDebugFrameBottomRight:SetTexture("Interface\\FriendsFrame\\WhoFrame-BotRight");
		myDebugVariableFrame:Show();
	elseif (tab == 2) then
		-- Scripts tab clicked
		myDebugVariableFrame:Hide();
		myDebugFrameBottomLeft:SetTexture("Interface\\FriendsFrame\\IgnoreFrame-BotLeft");
		myDebugFrameBottomCenterLeft:SetTexture("Interface\\FriendsFrame\\IgnoreFrame-BotLeft");
		myDebugFrameBottomCenterRight:SetTexture("Interface\\FriendsFrame\\IgnoreFrame-BotLeft");
		myDebugFrameBottomRight:SetTexture("Interface\\FriendsFrame\\IgnoreFrame-BotRight");
		myDebugScriptsFrame:Show();
	end

end

-- Variable button OnClick event
function myDebugVariableFrameButton_OnClick()

	-- Get the index of the button that was clicked
	local nodeIndex = myDebugVariableFrame_GetNodeIndex(this:GetID() + FauxScrollFrame_GetOffset(myDebugVariableFrameScrollFrame));
	
	-- Check if a node was clicked
	if (nodeIndex ~= 0) then
		local node = myDebugVariableTree[nodeIndex];
-- BEGIN Mikk 2006-05-09  We now store table references		
		if (type(node.value)=="table" and myDebugVariableTree.selectedIndex == nodeIndex) then
-- END Mikk 2006-05-09			
			if (node.expanded) then
				node.expanded = nil;
			else
				node.expanded = 1;
			end
		else
			myDebugVariableTree.selectedIndex = nodeIndex;
		end
		-- Update the variable tab display
		myDebugVariableFrame_Update();
	end

end

-- Script OnTextChanged event
function myDebugScriptsFrameEditBox_OnTextChanged()

	-- Get the script
	local script = myDebugScriptsFrameEditBox:GetText();
	
	-- Check if the script is empty
	if (script == "") then
		myDebugScripts[myDebugScripts.currentScript] = nil;
	else
		myDebugScripts[myDebugScripts.currentScript] = script;
	end

end;

-- Previous script OnClick event
function myDebugScriptsFramePrevScriptButton_OnClick()

	-- Set the new script
	myDebugScripts.currentScript = myDebugScripts.currentScript - 1;
	
	-- Update the scripts tab display
	myDebugScriptsFrame_Update();

end

-- Next script OnClick event
function myDebugScriptsFrameNextScriptButton_OnClick()

	-- Set the new script
	myDebugScripts.currentScript = myDebugScripts.currentScript + 1;
	
	-- Update the scripts tab display
	myDebugScriptsFrame_Update();

end


--------------------------------------------------------------------------------------------------
-- Initialize functions
--------------------------------------------------------------------------------------------------

-- Initialize the addon
function myDebugFrame_Initialize()

	-- Activate the variable tab
	myDebugFrameTab_OnClick(1);
	
	-- Initialize the variable tab display
	myDebugVariableFrame_Refresh();
	
	-- Initialize the scripts tab display
	myDebugScriptsFrame_InitializeScripts();
	myDebugScriptsFrame_Update();
	
	-- Check if myAddOns is loaded
	if (myAddOnsFrame_Register) then
		-- Initialize the addon's details
		local myDebugDetails = {
			name = MYDEBUG_NAME,
			version = MYDEBUG_VERSION,
			releaseDate = MYDEBUG_RELEASE_DATE,
			author = MYDEBUG_AUTHOR,
			email = MYDEBUG_EMAIL,
			website = MYDEBUG_WEBSITE,
			category = MYADDONS_CATEGORY_DEVELOPMENT
		};
		-- Initialize the addon's help
		local myDebugHelp = {
			MYDEBUG_HELP_PAGE1
		};
		-- Register the addon in myAddOns
		myAddOnsFrame_Register(myDebugDetails, myDebugHelp);
	else
		-- Display a message in the ChatFrame indicating a successful load of the addon
		DEFAULT_CHAT_FRAME:AddMessage(MYDEBUG_LOADED, 1.0, 1.0, 0.0);
	end

end

-- Initialize the scripts
function myDebugScriptsFrame_InitializeScripts()

	-- Check the current script
	if (not myDebugScripts.currentScript) then
		myDebugScripts.currentScript = 1;
	end

end


--------------------------------------------------------------------------------------------------
-- Display functions
--------------------------------------------------------------------------------------------------

-- Toggle the debug frame
function myDebugFrame_Toggle()

	-- Check if the debug frame is visible
	if (myDebugFrame:IsVisible()) then
		HideUIPanel(myDebugFrame);
	else
		ShowUIPanel(myDebugFrame);
	end

end

-- Refresh the variable tab display
function myDebugVariableFrame_Refresh()

	-- Build the tree for the typed variable name
	myDebugVariableFrame_BuildTree(myDebugVariableFrameEditBox:GetText());
	
	-- Update the display
	myDebugVariableFrame_Update();

end

-- BEGIN Mikk 2006-05-09

-- Escape a string according to C (LUA) escaping rules
function myDebugVariableFrame_EscapeString(str)
	return string.gsub(str, "([%c\"\\])", function(ch)
		if(ch=="\n") then
			return "\\n";
		elseif(ch=="\\") then
			return "\\\\";
		elseif(ch=="\"") then
			return "\\\"";
		elseif(ch=="\r") then
			return "\\r";
		elseif(ch=="\t") then
			return "\\t";
		end
		return string.format("\\x%02x", string.byte(ch,1));
	end);
end

-- Make a displayable string with quotes and truncation
function myDebugVariableFrame_MakeDisplayString(str,maxlen)
	
	if(maxlen<3) then
		maxlen=3;
	end
	
	local disp = myDebugVariableFrame_EscapeString(str);
		
	if(strlen(disp)>maxlen) then
		return "\"" .. string.sub(disp,1,maxlen).."\"... ("..strlen(str)..")";
	end
	
	return "\"" .. disp .."\"";
end
-- END

-- Update the variable tab display
function myDebugVariableFrame_Update()

	-- Get the number of visible nodes
	local numVisibleNodes = myDebugVariableFrame_GetNumVisibleNodes();
	
	-- Browse the lines
	for line = 1, 19, 1 do
		local nodeIndex = myDebugVariableFrame_GetNodeIndex(line + FauxScrollFrame_GetOffset(myDebugVariableFrameScrollFrame));
		-- Check if there is a node to display on the line
		if (nodeIndex ~= 0) then
			local node = myDebugVariableTree[nodeIndex];
			local nodeDepth = myDebugVariableFrame_GetDepth(nodeIndex);
			local color;
-- BEGIN Mikk 2006-05-09  We now store table references
			-- Check if the item is a table
			if (type(node.value) == "table") then
				color = HIGHLIGHT_FONT_COLOR;
				-- Show the toggle button
				if (node.expanded) then
					getglobal("myDebugVariableFrameButton"..line):SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
				else
					getglobal("myDebugVariableFrameButton"..line):SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				end
				getglobal("myDebugVariableFrameButton"..line.."Highlight"):SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight");
			else
				color = NORMAL_FONT_COLOR;
				-- Hide the toggle button
				getglobal("myDebugVariableFrameButton"..line):SetNormalTexture("");
				getglobal("myDebugVariableFrameButton"..line.."Highlight"):SetTexture("");
			end
-- END Mikk 2006-05-09			

			-- Indent with depth
			if (16 * nodeDepth < 527) then
				getglobal("myDebugVariableFrameButton"..line.."Name"):SetWidth(527 - 16 * nodeDepth)
				getglobal("myDebugVariableFrameButton"..line.."Name"):SetPoint("LEFT", "myDebugVariableFrameButton"..line, "LEFT", 29 + 16 * nodeDepth, 0);
				getglobal("myDebugVariableFrameButton"..line.."Normal"):SetPoint("LEFT", "myDebugVariableFrameButton"..line, "LEFT", 10 + 16 * nodeDepth, -1);
				getglobal("myDebugVariableFrameButton"..line.."Highlight"):SetPoint("LEFT", "myDebugVariableFrameButton"..line, "LEFT", 10 + 16 * nodeDepth, -1);
				-- Set the node's name
				getglobal("myDebugVariableFrameButton"..line.."Name"):SetTextColor(color.r, color.g, color.b);
-- BEGIN Mikk 2006-05-09  tostring node names, display complex types and ugly/long strings better, display messages
				local txt;
				if(type(node.name)=="string") then
					if(strlen(node.name)<32 and string.find(node.name, "^[%a_][%a%d_]*$")) then
						txt = node.name;
-- BEGIN Mikk 2006-07-02						
					elseif(nodeDepth==0) then
						txt = node.name; -- don't mangle the root node, it can contain whatever now
-- END Mikk 2006-07-02						
					else
						txt = "[" .. myDebugVariableFrame_MakeDisplayString(node.name, 32) .. "]";
					end
				else
					txt = "[" .. tostring(node.name) .. "]";
				end
				txt = txt .. " = ";
				-- Append value
				local v = node.value;
				if(type(v)=="string") then
					txt = txt .. myDebugVariableFrame_MakeDisplayString(v, 66 - (2.3*nodeDepth) - strlen(txt));
				else
					txt = txt..tostring(v);
					if(node.message) then -- display message if set (warnings about recursion)
						txt = txt .. " (" .. node.message .. ")";
					end
				end
				-- Display name + value
				getglobal("myDebugVariableFrameButton"..line.."Name"):SetText(txt);
-- END Mikk 2006-05-09
				-- Save the line's color
				getglobal("myDebugVariableFrameButton"..line).r = color.r;
				getglobal("myDebugVariableFrameButton"..line).g = color.g;
				getglobal("myDebugVariableFrameButton"..line).b = color.b;
				getglobal("myDebugVariableFrameButton"..line):Show();
			else
				getglobal("myDebugVariableFrameButton"..line):Hide();
			end
		else
			getglobal("myDebugVariableFrameButton"..line):Hide();
		end
	end
	
	-- Place/Remove the highlight
	myDebugVariableFrame_UpdateHighlight();
	
	-- Update the value field
	myDebugVariableFrame_UpdateValue();
	
	-- Enable/Disable the buttons
	myDebugVariableFrame_UpdateButtons();
	
	-- Scroll frame stuff
	FauxScrollFrame_Update(myDebugVariableFrameScrollFrame, numVisibleNodes, 19, 16);

end

-- Place/Remove the highlight
function myDebugVariableFrame_UpdateHighlight()

	-- Check if a line is selected and if it's visible
	if (myDebugVariableTree.selectedIndex ~= 0 and myDebugVariableFrame_IsVisible(myDebugVariableTree.selectedIndex)) then
		local selectedLine = myDebugVariableFrame_GetSelectedLine();
		-- Check if the selected node is currently displayed
		if (selectedLine > 0 and selectedLine <= 19) then
			getglobal("myDebugVariableFrameButton"..selectedLine.."Name"):SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
			myDebugVariableFrameHighlightFrame:SetPoint("TOPLEFT", "myDebugVariableFrameButton"..selectedLine, "TOPLEFT", 10, -1);
			myDebugVariableFrameHighlightFrame:Show();
		else
			myDebugVariableFrameHighlightFrame:Hide();
		end
	else
		myDebugVariableFrameHighlightFrame:Hide();
	end

end

-- Update the value field
function myDebugVariableFrame_UpdateValue()

	-- Check if a node is selected
	if (myDebugVariableTree.selectedIndex ~= 0) then
-- BEGIN Mikk 2006-05-09
		local node = myDebugVariableTree[myDebugVariableTree.selectedIndex];
		local value = node.value;
		local valueType = type(value);
		value = myDebugVariableFrame_EscapeString(tostring(value));
		myDebugVariableFrameTypeBorderLeft:Show();
		myDebugVariableFrameTypeBorderRight:Show();
		myDebugVariableFrameTypeText:SetText(valueType);
		myDebugVariableFrameValueText:SetText(value);
		myDebugVariableFrameValueText:Show();
		if(strlen(value)>50) then
			myDebugVariableFrameValueText:HighlightText(0,-1);
			myDebugVariableFrameValueText:SetFocus();
		else
			myDebugVariableFrameValueText:ClearFocus();
		end
	else
		myDebugVariableFrameTypeBorderLeft:Hide();
		myDebugVariableFrameTypeBorderRight:Hide();
		myDebugVariableFrameTypeText:SetText("");
		myDebugVariableFrameValueText:Hide();
-- END Mikk 2006-05-09
	end

end

-- Enable/Disable the buttons
function myDebugVariableFrame_UpdateButtons()

--BEGIN Mikk 2006-07-02  - Insert button enabled in the root node also! (But only if it's a table!)
	if(myDebugVariableTree[myDebugVariableTree.selectedIndex] and type(myDebugVariableTree[1].value) == "table") then
		myDebugVariableFrameInsertButton:Enable();
	else
		myDebugVariableFrameInsertButton:Disable();
	end

	-- Check if a node is selected
	if (myDebugVariableTree.selectedIndex ~= 0 and myDebugVariableTree[myDebugVariableTree.selectedIndex].parentIndex ~= 0) then
		myDebugVariableFrameEditButton:Enable();
		myDebugVariableFrameDeleteButton:Enable();
	else
		myDebugVariableFrameEditButton:Disable();
		myDebugVariableFrameDeleteButton:Disable();
	end
--END Mikk 2006-07-02
end

-- Update the scripts tab display
function myDebugScriptsFrame_Update()

	-- Get the current script
	script = myDebugScripts[myDebugScripts.currentScript];
	
	-- Check if the current script is empty
	if (script) then
		myDebugScriptsFrameEditBox:SetText(script);
	else
		myDebugScriptsFrameEditBox:SetText("");
	end
	
	-- Set the script number
	myDebugScriptsFrameScriptNumberText:SetText(myDebugScripts.currentScript);
	
	-- Enable/Disable the buttons
	myDebugScriptsFrame_UpdateButtons();

end

-- Enable/Disable the buttons
function myDebugScriptsFrame_UpdateButtons()

	-- Check if the current script is the first one
	if (myDebugScripts.currentScript == 1) then
		myDebugScriptsFramePrevScriptButton:Disable();
	else
		myDebugScriptsFramePrevScriptButton:Enable();
	end

end


--------------------------------------------------------------------------------------------------
-- Tree functions
--------------------------------------------------------------------------------------------------

-- BEGIN Mikk 2006-07-02
function myDebug_GetVar(variableName)
	local chunk,msg = loadstring("return "..variableName);
	if(not chunk) then
		message(MYDEBUG_NAME..": "..msg);
		return;
	end
	local ret = { chunk() };
	if(table.getn(ret)<=1) then return ret[1]; end
	return ret;
end
-- END Mikk 2006-07-02

-- Build the variable's tree
function myDebugVariableFrame_BuildTree(variableName)

	-- Empty the tree
	myDebugVariableTree = {};
	myDebugVariableTree.selectedIndex = 0;
		
	-- Get the variable
-- BEGIN Mikk 2006-07-02 getglobal() -> myDebug_GetVar()
	local variable = myDebug_GetVar(variableName);
-- END Mikk 2006-07-02
	
	-- Check if the variable does exist
	if (variable) then
-- BEGIN Mikk 2006-05-07  depth counter		
		myDebugVariableFrame_BuildNode(nil, 0, variableName, {});
	elseif (variableName ~= "") then
		message(MYDEBUG_NAME..": "..variableName..MYDEBUG_VARIABLE_ERROR);
-- END Mikk 2006-05-07
	end

end

-- Build a node of the variable's tree
-- BEGIN Mikk 2006-05-07  depth counter		
function myDebugVariableFrame_BuildNode(parent, parentIndex, nodeName, parents)
-- END Mikk 2006-05-07
	-- Get the current node
	local node;
	if (parent) then
		node = parent[nodeName];
	else
-- BEGIN Mikk 2006-07-02 getglobal->myDebug_GetVar		
		node = myDebug_GetVar(nodeName);
-- END Mikk 2006-07-02
	end;
	
	-- Get the type of the node
	local nodeType = type(node);
	
-- BEGIN Mikk 2006-05-07  depth counter
-- BEGIN Mikk 2006-05-09  Store table references, and use "message" member for warning message. also display nontables before tables.
	-- Check the type of the node
	if (nodeType == "table") then
		-- Max depth exceeded?
		if(table.getn(parents)>=MYDEBUG_MAXTREEDEPTH) then
			table.insert(myDebugVariableTree, {name = nodeName, parentIndex = parentIndex, expanded = 1, value = node, message = "depth >"..MYDEBUG_MAXTREEDEPTH});
		else
			-- Check that we're not linking back to a forefather
			local p,backref;
			for _,p in parents do
				if(p==node) then
					table.insert(myDebugVariableTree, {name = nodeName, parentIndex = parentIndex, expanded = 1, value = node, message = "recursive backreference"});
					backref=true;
				end
			end
			-- Good to go, add table members
			if(not backref) then
				tinsert(parents, node);
				table.insert(myDebugVariableTree, {name = nodeName, parentIndex = parentIndex, expanded = 1, value = node});
				local currentIndex = table.getn(myDebugVariableTree);
				-- nontables first
				for childNode in node do
					if(type(node[childNode])~="table") then
						myDebugVariableFrame_BuildNode(node, currentIndex, childNode, parents);
					end
				end
				-- now tables
				for childNode,childData in node do
					if(type(node[childNode])=="table") then
						myDebugVariableFrame_BuildNode(node, currentIndex, childNode, parents);
					end
				end
				tremove(parents);
			end
		end
	else
		-- Regular variable
		table.insert(myDebugVariableTree, {name = nodeName, parentIndex = parentIndex, expanded = 1, value = node});
	end
-- END Mikk 2006-05-09				
-- END Mikk 2006-05-07

end

-- Check if the node is visible
function myDebugVariableFrame_IsVisible(nodeIndex)

	-- Get the parent index
	local parentIndex = myDebugVariableTree[nodeIndex].parentIndex;
	
	-- Check if the parent is expanded
	if (parentIndex == 0) then
		return true;
	else
		if (myDebugVariableTree[parentIndex].expanded) then
			return myDebugVariableFrame_IsVisible(parentIndex);
		else
			return false;
		end
	end

end

-- Get the number of visible nodes in the tree
function myDebugVariableFrame_GetNumVisibleNodes()

	local numVisibleNodes = 0;
	
	-- Browse the tree
	for nodeIndex = 1, table.getn(myDebugVariableTree), 1 do
		-- Check if the node is visible
		if (myDebugVariableFrame_IsVisible(nodeIndex)) then
			numVisibleNodes = numVisibleNodes + 1;
		end
	end
	
	return numVisibleNodes;

end

-- Get the index in the tree of the selected line
function myDebugVariableFrame_GetNodeIndex(selectedLine)

	local line = 0;
	
	-- Browse the tree
	for nodeIndex = 1, table.getn(myDebugVariableTree), 1 do
		-- Check if the node is visible
		if (myDebugVariableFrame_IsVisible(nodeIndex)) then
			line = line + 1;
		end
		-- Check if it has reached the selected line
		if (line == selectedLine) then
			return nodeIndex;
		end
	end
	
	return 0;

end

-- Get the line of the selected node
function myDebugVariableFrame_GetSelectedLine()

	local selectedLine = -FauxScrollFrame_GetOffset(myDebugVariableFrameScrollFrame);
	
	for nodeIndex = 1, myDebugVariableTree.selectedIndex, 1 do
		-- Check if the node is visible
		if (myDebugVariableFrame_IsVisible(nodeIndex)) then
			selectedLine = selectedLine + 1;
		end
	end
	
	return selectedLine;

end

-- Get the depth of a node
function myDebugVariableFrame_GetDepth(nodeIndex)

	-- Get the parent index
	local parentIndex = myDebugVariableTree[nodeIndex].parentIndex;
	
	if (parentIndex == 0) then
		return 0;
	else
		return 1 + myDebugVariableFrame_GetDepth(parentIndex);
	end

end

-- Get the variable of a node
function myDebugVariableFrame_GetVariable(nodeIndex)

	-- Get the node
	local node = myDebugVariableTree[nodeIndex];
	
	if (node.parentIndex == 0) then
-- BEGIN Mikk 2006-07-02 getglobal() -> myDebug_GetVar		
		return myDebug_GetVar(node.name);
-- END Mikk 2006-07-02
	else
		return myDebugVariableFrame_GetVariable(node.parentIndex)[node.name];
	end

end

-- Insert a variable
function myDebugVariableFrame_InsertVariable(parentIndex, variableName, value)

	-- Check if the parentIndex is populated
	if (not parentIndex) then
		parentIndex = myDebugVariableTree.selectedIndex;
	end
	
	local parameters = {parentIndex = parentIndex, variableName = variableName, value = value};
	
	-- Check if the parent node is a table
	if (type(myDebugVariableFrame_GetVariable(parentIndex)) ~= "table") then
		local dialog = StaticPopup_Show("MYDEBUG_VARIABLE_INSERT_FORCE");
		dialog.data = parameters;
		return;
	end
	
	-- Check if the variable name is populated
	if (not variableName) then
		local dialog = StaticPopup_Show("MYDEBUG_VARIABLE_INSERT_NAME");
		dialog.data = parameters;
		return;
	end
	
	-- Check if the value is populated
	if (not value) then
		local dialog = StaticPopup_Show("MYDEBUG_VARIABLE_INSERT_VALUE");
		dialog.data = parameters;
		return;
	end
	
	-- Check if the value is a boolean or a number
	if (value == "true") then
		value = true;
	elseif (value == "false") then
		value = false;
-- BEGIN Mikk 2006-07-02 - Just test the conversion. Accepts decimal point values that way, too.
	elseif (tonumber(value)) then
-- END Mikk 2006-07-02
		value = tonumber(value);
	end
	
	-- Insert the variable
	myDebugVariableFrame_GetVariable(parentIndex)[variableName] = value;
	
	-- Update the display
	myDebugVariableFrame_Refresh();

end

-- Edit the value of a node
function myDebugVariableFrame_EditVariable(nodeIndex, value)

	-- Get the node
	local node = myDebugVariableTree[nodeIndex];
	
	-- Get the type of the variable
	local variableType = type(node.value);
	
	-- Check if the variable is a boolean
	if (variableType == "boolean") then
		if (value == "true") then
			value = true;
		elseif (value == "false") then
			value = false;
		end
	end
	
	-- Check if the variable is a number
-- BEGIN Mikk 2006-07-02 - Just test the conversion. Accepts decimal point values that way, too.
	if (tonumber(value)) then
-- END Mikk 2006-07-02
		value = tonumber(value);
	end
	
	-- Edit the variable of the node
	myDebugVariableFrame_GetVariable(node.parentIndex)[node.name] = value;
	
end


--------------------------------------------------------------------------------------------------
-- Scripts functions
--------------------------------------------------------------------------------------------------

-- Clear a script or all scripts
function myDebugScriptsFrame_Clear(scriptNumber)

	-- Check if clearing a script or all scripts
	if (scriptNumber) then
		myDebugScripts[scriptNumber] = nil;
		if (myDebugScripts.currentScript == scriptNumber) then
			myDebugScriptsFrameEditBox:SetText("");
		end
		DEFAULT_CHAT_FRAME:AddMessage("Script "..scriptNumber..MYDEBUG_SCRIPTS_CLEARED, 1.0, 1.0, 0.0);
	else
		myDebugScripts = {};
		myDebugScriptsFrame_InitializeScripts();
		DEFAULT_CHAT_FRAME:AddMessage(MYDEBUG_SCRIPTS_CLEARED_ALL, 1.0, 1.0, 0.0);
	end
	
	-- Update the scripts tab display
	myDebugScriptsFrame_Update();

end


-- BEGIN Mikk 2006-05-07	
-- Begin editing a given script
function myDebugScriptsFrame_Goto(scriptNumber)
	if(scriptNumber < 1 or scriptNumber > 999) then
		message(MYDEBUG_NAME..": "..string.format(MYDEBUG_SCRIPTS_NOSUCHSCRIPT, scriptNumber));
		return;
	end
	
	-- Set the new script
	myDebugScripts.currentScript = scriptNumber;
	
	-- Update the scripts tab display
	myDebugScriptsFrame_Update();
end
-- END Mikk 2006-05-07	


-- Execute a script
function myDebugScriptsFrame_Execute(scriptNumber)

-- BEGIN Mikk 2006-05-07	  Needed because this is called with user input now
	if(not myDebugScripts[scriptNumber]) then
		message(MYDEBUG_NAME..": "..string.format(MYDEBUG_SCRIPTS_NOSUCHSCRIPT, scriptNumber));
		return;
	end
-- END Mikk 2006-05-07	

	-- Execute the script
	RunScript(myDebugScripts[scriptNumber]);
	DEFAULT_CHAT_FRAME:AddMessage("Script "..scriptNumber..MYDEBUG_SCRIPTS_EXECUTED, 1.0, 1.0, 0.0);
	PlaySound("igMainMenuOpen");
	
	-- Update the scripts tab display
	myDebugScriptsFrame_Update();

end

