-- Four Horsemen by Lowanaera of Heist

--Variable Declaration
local fourhorsemen_meteorlockout = nil;
local horsemen_deaths = 0;
local fourhorsemen_rotationlockout = nil;

--Activate, Event Binds
function RDXM.NAXW.FourhorsemenActivate()
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("PLAYER_REGEN_DISABLED"), function() RDX.StartEncounter(); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"), function() RDXM.NAXW.FourhorsemenMeteor(arg1); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"), function() RDXM.NAXW.FourhorsemenMeteor(arg1); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"), function() RDXM.NAXW.FourhorsemenMeteor(arg1); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"), function() RDXM.NAXW.FourhorsemenRotation(arg1); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"), function() RDXM.NAXW.FourhorsemenRotation(arg1); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"), function() RDXM.NAXW.FourhorsemenRotation(arg1); end);
	VFLEvent:NamedBind("fourhorsemen", BlizzEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH"), function() RDXM.NAXW.FourhorsemenUnitDeath(arg1); end);
end

--Deactivate, Clear Binds
function RDXM.NAXW.FourhorsemenDeactivate()
	VFLEvent:NamedUnbind("fourhorsemen");
end

--Start
function RDXM.NAXW.FourhorsemenStart()
	--First Mark pre-warning
	RDX.Alert.Dropdown("fourhorsemen_startwarn", "Mark One in approximately", 20, 4, nil, nil, {r=1, g=0, b=1});
end

--Stop
function RDXM.NAXW.FourhorsemenStop()
	--Clear Alerts
	RDX.QuashAlertsByPattern("^fourhorsemen")
end

--Update Control, does nothing for this encounter
function RDXM.NAXW.FourhorsemenUpdate()
end

--Controls Mark Rotation Start
function RDXM.NAXW.FourhorsemenRotation(arg)
	--Check for Mark to land
	if string.find(arg,"is afflicted by Mark of ") then
		--Check for Rotation in-progress
		if fourhorsemen_rotationlockout then return; end
		--Start Rotation
		RDXM.NAXW.FourhorsemenRotationAlerts();
		--Set lockout to prevent rotation re-start
		fourhorsemen_rotationlockout = true;
		--Schedule unlocking for next rotation
		VFL.schedule(142, function() fourhorsemen_rotationlockout = false; end);
	end
end

--Mark Rotation Alerts
function RDXM.NAXW.FourhorsemenRotationAlerts()
	RDX.Alert.Simple("Mark One - Stay Put!", nil, 4, false);
	VFL.scheduleExclusive("fourhorsemen_marktwoT", 12, function() RDX.Alert.Dropdown("fourhorsemen_marktwotimer", "Mark Two in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_marktwoS", 12, function() RDX.Alert.Simple("Mark Two - Evens Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_markthreeT", 24, function() RDX.Alert.Dropdown("fourhorsemen_markthreetimer", "Mark Three in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_markthreeS", 24, function() RDX.Alert.Simple("Mark Three - Odds Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_markfourT", 36, function() RDX.Alert.Dropdown("fourhorsemen_markfourtimer", "Mark Four in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_markfourS", 36, function() RDX.Alert.Simple("Mark Four - Stay Put!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_markfiveT", 48, function() RDX.Alert.Dropdown("fourhorsemen_markfivetimer", "Mark Five in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_markfiveS", 48, function() RDX.Alert.Simple("Mark Five - Evens Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_marksixT", 60, function() RDX.Alert.Dropdown("fourhorsemen_marksixtimer", "Mark Six in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_marksixS", 60, function() RDX.Alert.Simple("Mark Six - Odds Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_marksevenT", 72, function() RDX.Alert.Dropdown("fourhorsemen_markseventimer", "Mark Seven in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_marksevenS", 72, function() RDX.Alert.Simple("Mark Seven - Stay Put!!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_markeightT", 84, function() RDX.Alert.Dropdown("fourhorsemen_markeighttimer", "Mark Eight in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_markeightS", 84, function() RDX.Alert.Simple("Mark Eight - Evens Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_marknineT", 96, function() RDX.Alert.Dropdown("fourhorsemen_markninetimer", "Mark Nine in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_marknineS", 96, function() RDX.Alert.Simple("Mark Nine - Odds Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_marktenT", 108, function() RDX.Alert.Dropdown("fourhorsemen_marktentimer", "Mark Ten in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_marktenS", 108, function() RDX.Alert.Simple("Mark Ten - Stay Put!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_markelevenT", 120, function() RDX.Alert.Dropdown("fourhorsemen_markeleventimer", "Mark Eleven in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_markelevenS", 120, function() RDX.Alert.Simple("Mark Eleven - Evens Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_marktwelveT", 132, function() RDX.Alert.Dropdown("fourhorsemen_marktwelvetimer", "Mark Twelve in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
	VFL.scheduleExclusive("fourhorsemen_marktwelveS", 132, function() RDX.Alert.Simple("Mark Twelve - Odds Move!", nil, 4, false); end);
	VFL.scheduleExclusive("fourhorsemen_markoneT", 144, function() RDX.Alert.Dropdown("fourhorsemen_markonetimer", "Mark One in", 12, 4, nil, nil, {r=1, g=.2, b=.2}); end);
end

--Autostops encounter on win
function RDXM.NAXW.FourhorsemenUnitDeath(arg1)
	if (string.find(arg1, "Mograine")) or
		(string.find(arg1, "Thane")) or
		(string.find(arg1, "Lady")) or
		(string.find(arg1, "Zeliek")) then
			horsemen_deaths = horsemen_deaths + 1
			if horsemen_deaths == 4 then
				RDX.Alert.Simple("Hardkore with <3!", nil, 5, false);
				RDX.StopEncounter();
			end
	end
end

--Controls Meteor Warnings
function RDXM.NAXW.FourhorsemenMeteor(arg)
	--Check for meteor hitting
	if string.find(arg,"Thane Korth'azz's Meteor hits ") then
		--Check for lockout
		if fourhorsemen_meteorlockout then return; end
		--Start alert
		RDXM.NAXW.FourhorsemenMeteorAlert()
		--Set lockout
		fourhorsemen_meteorlockout = true;
		--Schedule unlocking for next meteor
		VFL.schedule(11, function() fourhorsemen_meteorlockout = false; end);
	end
end

--Meteor Warnings
function RDXM.NAXW.FourhorsemenMeteorAlert()
	RDX.Alert.Simple("METEOR!", nil, 4, false);
	RDX.Alert.Dropdown("fourhorsemen_meteor", "Next Meteor in", 12, 4, nil, {r=1, g=0, b=1});
end

--Encounter Registering
RDXM.NAXW.enctbl["fourhorsemen"] = {
	ActivateEncounter = RDXM.NAXW.FourhorsemenActivate;
	DeactivateEncounter = RDXM.NAXW.FourhorsemenDeactivate;
	StartEncounter = RDXM.NAXW.FourhorsemenStart;
	StopEncounter = RDXM.NAXW.FourhorsemenStop;
};